#!/bin/sh
# 
# 2008      Nico Schottelius (nico-gpm2008 at schottelius.org)
# 
# This file is part of gpm.
#
# gpm is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.
# 
# gpm is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with gpm. If not, see <http://www.gnu.org/licenses/>.
#

cd "$1"

cat << eof
/*
 * Warning: This file is autogenerated by $0.
 *
 * DO NOT EDIT IT, ALL CHANGES WILL BE LOST IN ANY CASE.
 *
 */

#ifndef __GPM_DRIVER_H
#define __GPM_DRIVER_H

eof

(
   grep -h "^int M_"    drivers/*/m.c
   #grep -h "^Gpm_Type"  drivers/*/i.c
   # they have line breaks :-(
   cat drivers/*/i.c |  \
      awk 'BEGIN { RS="{"; }
            /Gpm_Type[ 	][ 	]*\*I_/ {
               idx=index($0,"Gpm_Type *I_");
               fn=substr($0, idx);
               gsub(/\n/, " ", fn);
               print fn
            }'
   grep -h "^int R_"    drivers/*/r.c
) | sed -e '/^$/d' -e 's/$/;/' -e 's/  */ /g'

echo "#endif"
